﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Syncfusion.DocIO;
using Syncfusion.DocIO.DLS;
using System.IO;
namespace SyncfusionMvcApplication1
{
    public partial class RichTextEditorController : Controller
    {
        //
        // GET: /EditorsPackage/
        public ActionResult RichTextEditorFeatures()
        {
            return View();
        }
        [HttpPost]
        public string Import()
        {
            string HtmlString = string.Empty;
            if (HttpContext.Request.Files.AllKeys.Any())
            {
                var httpPostedFile = HttpContext.Request.Files["upload"];
                if (httpPostedFile != null)
                {
                    using (var mStream = new MemoryStream())
                    {
                        new WordDocument(httpPostedFile.InputStream).Save(mStream, FormatType.Html);
                        mStream.Position = 0;
                        HtmlString = new StreamReader(mStream).ReadToEnd();
                    };

                    HtmlString = ExtractBodyContent(HtmlString);

                    foreach (var item in DecodeKeys())
                    {
                        HtmlString = HtmlString.Replace(item.Key, item.Value);
                    }
                }
                else HttpContext.Response.Write("Select any file to upload.");

            }
            return HtmlString;
        }
        //public ActionResult Import(IEnumerable<HttpPostedFileBase> upload)
        //{
        //    foreach (var file in upload)
        //    {
        //        var fileName = Path.GetFileName(file.FileName);
        //        BinaryReader b = new BinaryReader(file.InputStream);
        //        byte[] binData = b.ReadBytes(file.ContentLength);

        //        var str = System.Text.Encoding.Default.GetString(binData);
        //       // string result = new StreamReader(file.InputStream).ReadToEnd();
        //        var destinationPath = Path.Combine(Server.MapPath("~/App_Data"), fileName);

        //    }

        //    //string HtmlString = string.Empty;
        //    //HttpRequest request = context.Request;
        //    //string requestPath = context.Request.UrlReferrer.AbsolutePath;
        //    //HttpFileCollection uploadedFiles = context.Request.Files;

        //    //if (uploadedFiles != null && uploadedFiles.Count > 0 && uploadedFiles[0].FileName != "")
        //    //{
        //    //    for (int i = 0; i < uploadedFiles.Count; i++)
        //    //    {
        //    //        if (uploadedFiles[i].FileName != null && uploadedFiles[i].FileName != "")
        //    //        {
        //    //            string fileName = uploadedFiles[i].FileName;

        //    //            int indx = fileName.LastIndexOf("\\");
        //    //            if (indx > -1)
        //    //            {
        //    //                fileName = fileName.Substring(indx + 1);
        //    //            }

        //    //            using (var mStream = new MemoryStream())
        //    //            {
        //    //                new WordDocument(uploadedFiles[0].InputStream).Save(mStream, FormatType.Html);
        //    //                mStream.Position = 0;
        //    //                HtmlString = new StreamReader(mStream).ReadToEnd();
        //    //            };

        //    //            HtmlString = ExtractBodyContent(HtmlString);

        //    //            foreach (var item in DecodeKeys())
        //    //            {
        //    //                HtmlString = HtmlString.Replace(item.Key, item.Value);
        //    //            }
        //    //        }
        //    //        else HttpContext.Response.Write("Select any file to upload.");

        //    //    }
        //    //  //  return HtmlString;


        //    //    // only for Synchronous upload functionalities

        //    //}
        //    //else
        //    //{
        //    //    // only for Synchronous upload functionalities 

        //    //    if (requestPath.Contains("synchronous.html") || requestPath.Contains("saveFiles.ashx"))
        //    //    {
        //    //        context.Response.Write("<span id='successmsg'> Select file to upload</span>");
        //    //        context.Response.WriteFile("synchronous.html");
        //    //    }
        //    //}
        //    return Content("");
        //}

        public string ExtractBodyContent(string html)
        {
            if (html.Contains("<html") && html.Contains("<body"))
            {
                return html.Remove(0, html.IndexOf("<body>") + 6).Replace("</body></html>", "");

            }
            return html;
        }
        public IDictionary<string, string> DecodeKeys()
        {
            IDictionary<string, string> KeyValuePair = new Dictionary<string, string>()
            {
               {"\"", "'"},{"\r", " "},{"\n", "<br/> "},{"\r\n", " "},{"( )+", " "},{"&nbsp;", " "},{"&bull;", "*"},{"&lsaquo;", "<"},
               {"&rsaquo;", ">"},{"&trade;", "(tm)"},{"&copy;", "(c)"},{"&reg;", "(r)"}
            };

            return KeyValuePair;
        }



    }
}
